storage.BSCpPcurrentStreak = {}--or ...Entities if CountEntities
storage.BSCpPTickOfLastEvent = {}
storage.BSCpPLastBlueprint = {}
storage.BSCpPDivisor = {}
script.on_event(defines.events.on_built_entity, function(event)
local ThisPlayer = game.players[event.player_index]
local TimingWindow = ThisPlayer.mod_settings["streak-timing-window-in-ticks"].value
local displayInvalidStackInfo = ThisPlayer.mod_settings["invalid-stack-info"].value
local PrintInChat = ThisPlayer.mod_settings["print-in-chat"].value
local PrintAtCursor = ThisPlayer.mod_settings["print-at-cursor"].value
local CountEntities = ThisPlayer.mod_settings["count-entities"].value
local CountEntitiesGUIClickSoundVolume = ThisPlayer.mod_settings["gui-click-sound-volume"].value
local MinimumBlueprintSize = ThisPlayer.mod_settings["minimum-amount-for-click-sound"].value
local ThisTick = event.tick
local cs = ThisPlayer.cursor_stack
local CanOnlyBeCalledOncePerTick = ThisTick ~= storage.BSCpPTickOfLastEvent[ThisPlayer.name]
if storage.BSCpPcurrentStreak[ThisPlayer.name] == nil then
    storage.BSCpPcurrentStreak[ThisPlayer.name]=0
    storage.BSCpPLastBlueprint[ThisPlayer.name]=-1
    storage.BSCpPTickOfLastEvent[ThisPlayer.name]=0
    storage.BSCpPDivisor[ThisPlayer.name]=1
end
    if cs.valid_for_read and not cs.is_blueprint_book then--
        if cs.is_blueprint_setup() and (CountEntities or CanOnlyBeCalledOncePerTick) then
            local CurrentBlueprint = cs.item_number
            storage.BSCpPcurrentStreak[ThisPlayer.name] = storage.BSCpPcurrentStreak[ThisPlayer.name]+1
            if (ThisTick-storage.BSCpPTickOfLastEvent[ThisPlayer.name])>TimingWindow or storage.BSCpPLastBlueprint[ThisPlayer.name] ~= CurrentBlueprint then
                storage.BSCpPcurrentStreak[ThisPlayer.name]=1
            end
            if CountEntities and CanOnlyBeCalledOncePerTick then
                storage.BSCpPDivisor[ThisPlayer.name]= cs.get_blueprint_entity_count()+#(cs.get_blueprint_tiles() or {})
            end
            storage.BSCpPTickOfLastEvent[ThisPlayer.name]=ThisTick
            storage.BSCpPLastBlueprint[ThisPlayer.name]=CurrentBlueprint
            local result=0
            if CountEntities then
                result = (math.floor(storage.BSCpPcurrentStreak[ThisPlayer.name] / storage.BSCpPDivisor[ThisPlayer.name]))
                if storage.BSCpPcurrentStreak[ThisPlayer.name] % storage.BSCpPDivisor[ThisPlayer.name] == 0 and helpers.is_valid_sound_path("utility/gui_click") and (storage.BSCpPDivisor[ThisPlayer.name])>=MinimumBlueprintSize then
                    ThisPlayer.force.play_sound{path="utility/gui_click", position=(ThisPlayer.position), volume_modifier=CountEntitiesGUIClickSoundVolume}
                end
            else
                result =  storage.BSCpPcurrentStreak[ThisPlayer.name]
            end
            if result>1 then
                if PrintInChat then
                    ThisPlayer.print(result)
                end
                if PrintAtCursor then
                    ThisPlayer.create_local_flying_text{text=result, create_at_cursor=true} --, time_to_live=120, speed=1, color={0,221,0} if create_at_cursor then no impact
                end
            end
    else
        if not cs.valid_for_read and displayInvalidStackInfo then
            ThisPlayer.print({"info-message.stack-invalid"})
        end
    end
    end
end)--[[,
{{filter= "ghost"}})
]]