--settings.lua
data:extend({
    {
        type = "int-setting",
        name = "streak-timing-window-in-ticks",
        setting_type = "runtime-per-user",
        minimum_value = 1,
        default_value = 240
    },
    {
        type = "int-setting",
        name = "minimum-amount-for-click-sound",
        setting_type = "runtime-per-user",
        minimum_value = 1,
        default_value = 6
    },
    {
        type = "bool-setting",
        name = "invalid-stack-info",
        setting_type = "runtime-per-user",
        default_value = true
    },
    {
        type = "bool-setting",
        name = "count-entities",
        setting_type = "runtime-per-user",
        default_value = false
    },
    {
        type = "double-setting",
        name = "gui-click-sound-volume",
        setting_type = "runtime-per-user",
        default_value = 0,
        minimum_value = 0,
        maximum_value = 1
    },
    {
        type = "bool-setting",
        name = "print-in-chat",
        setting_type = "runtime-per-user",
        default_value = false
    },
    {
        type = "bool-setting",
        name = "print-at-cursor",
        setting_type = "runtime-per-user",
        default_value = true
    }
})